package br.ufpe.cin.rgms.linhasdepesquisa.apresentacao;

import java.io.IOException;
import java.util.List;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import br.ufpe.cin.rgms.Facade;
import br.ufpe.cin.rgms.linhasdepesquisa.modelo.LinhaPesquisa;
import br.ufpe.cin.rgms.membro.modelo.Membro;
import br.ufpe.cin.rgms.publicacao.modelo.Publicacao;
import br.ufpe.cin.rgms.util.StringsUtil;

public class AdicionarLinhaPesquisaServlet extends HttpServlet {

	public void doPost( HttpServletRequest request, 
			HttpServletResponse response) 
	throws IOException, ServletException {

		if(((Membro) request.getSession().getAttribute("usuario")) == null){
			response.sendRedirect("index.jsp");
		}
		else{
			String titulo = request.getParameter("titulo");

			String breveDescricao = request.getParameter("breve_descricao");

			String descricaoDetalhada = request.getParameter("descricao_detalhada");

			List<String> financiadores = StringsUtil.getElementsWithSplitAndTrim(request.getParameter("financiadores"));

			List<String> linksRelacionados = StringsUtil.getElementsWithSplitAndTrim(request.getParameter("links_relacionados"));

			List<Membro> membros = StringsUtil.getMembros(request.getParameter("membros"));

			List<Publicacao> publicacoes = StringsUtil.getPublicacoes(request.getParameter("publicacoes"));

			LinhaPesquisa linhaPesquisa = new LinhaPesquisa(titulo,breveDescricao,descricaoDetalhada,financiadores,linksRelacionados,membros,publicacoes);

			try {
				Facade.getInstance().inserirLinhaPesquisa(linhaPesquisa);
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();

				request.setAttribute("linhapesquisastatus", "No foi possvel inserir a linha no banco de dados. Verifique possveis erros.");
			}

			request.setAttribute("linhapesquisastatus", "Linha de pesquisa inserida com sucesso.");

			RequestDispatcher view = request.getRequestDispatcher("linhapesquisastatus.jsp");
			view.forward(request, response);
		}
	}
}
