package br.ufpe.cin.rgms.linhasdepesquisa.apresentacao;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import br.ufpe.cin.rgms.Facade;
import br.ufpe.cin.rgms.linhasdepesquisa.modelo.LinhaPesquisa;
import br.ufpe.cin.rgms.membro.modelo.Membro;
import br.ufpe.cin.rgms.publicacao.modelo.Publicacao;
import br.ufpe.cin.rgms.util.Properties;
import br.ufpe.cin.rgms.util.StringsUtil;

public class AlterarDadosLinhaPesquisaServlet extends HttpServlet {

	private List<String> getElementsWithSplitAndTrim(String financiadores) {
		String[] strigsFinacionadores = financiadores.split(",");
		List<String> retorno = new ArrayList<String>();

		for(String financador : strigsFinacionadores){
			retorno.add(financador.trim());
		}

		return retorno;
	}

	public void doPost( HttpServletRequest request, 
			HttpServletResponse response) 
	throws IOException, ServletException {

		if(((Membro) request.getSession().getAttribute("usuario")) == null){
			response.sendRedirect("index.jsp");
		}
		else{
			String titulo = request.getParameter("titulo");

			String breveDescricao = request.getParameter("breve_descricao");

			String descricaoDetalhada = request.getParameter("descricao_detalhada");

			List<String> financiadores = this.getElementsWithSplitAndTrim(request.getParameter("financiadores"));

			List<String> linksRelacionados = this.getElementsWithSplitAndTrim(request.getParameter("links_relacionados"));

			List<Membro> membros = StringsUtil.getMembros(request.getParameter("membros"));

			List<Publicacao> publicacoes = StringsUtil.getPublicacoes(request.getParameter("publicacoes"));

			LinhaPesquisa linhaParaAlterar = Facade.getInstance().getLinhaPesquisa(Integer.parseInt(request.getParameter("linha")));

			linhaParaAlterar.setTitulo(titulo);
			linhaParaAlterar.setBreveDescricao(breveDescricao);
			linhaParaAlterar.setDescricaoDetalhada(descricaoDetalhada);
			linhaParaAlterar.setFinanciadores(financiadores);
			linhaParaAlterar.setLinksRelacionados(linksRelacionados);
			
			for(Membro membroAntigo : linhaParaAlterar.getMembros()){
				if(!membros.contains(membroAntigo)){
					linhaParaAlterar.getMembros().remove(membroAntigo);
				}
			}
			
			for(Membro membroNovo : membros){
				if(!linhaParaAlterar.getMembros().contains(membroNovo)){
					linhaParaAlterar.getMembros().add(membroNovo);
				}
			}
			
			for(Publicacao publicacaoAntiga : linhaParaAlterar.getPublicacoes()){
				if(!publicacoes.contains(publicacaoAntiga)){
					linhaParaAlterar.getPublicacoes().remove(publicacaoAntiga);
				}
			}
			
			for(Publicacao publicacaoNova : publicacoes){
				if(!linhaParaAlterar.getPublicacoes().contains(publicacaoNova)){
					linhaParaAlterar.getPublicacoes().add(publicacaoNova);
				}
			}

			try{
				Facade.getInstance().alterarLinhaPesquisa(linhaParaAlterar);

				request.setAttribute("linhapesquisastatus", Properties.getProperty("linha_alterada_sucesso"));

			}catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();

				request.setAttribute("linhapesquisastatus", Properties.getProperty("erro_atualizacao_linha"));
			}

			RequestDispatcher view = request.getRequestDispatcher("linhapesquisastatus.jsp");
			view.forward(request, response);
		}
	}
	
}
