
package br.ufpe.cin.rgms.linhasdepesquisa.controle;

import java.util.HashMap;
import java.util.List;

import br.ufpe.cin.rgms.base.Controle;
import br.ufpe.cin.rgms.base.Persistence;
import br.ufpe.cin.rgms.base.RGMSException;
import br.ufpe.cin.rgms.linhasdepesquisa.modelo.LinhaPesquisa;
import br.ufpe.cin.rgms.linhasdepesquisa.persistencia.DaoLinhaPesquisa;
import br.ufpe.cin.rgms.membro.modelo.Membro;

public class ControleLinhaPesquisa extends Controle<LinhaPesquisa,DaoLinhaPesquisa> {

	public ControleLinhaPesquisa() {
		super(new DaoLinhaPesquisa());
	}

	@Override
	protected void validar(LinhaPesquisa objeto) throws RGMSException {
		if(objeto.getBreveDescricao() == null || objeto.getBreveDescricao().equals("") ||
				objeto.getDescricaoDetalhada() == null || objeto.getDescricaoDetalhada().equals("") ||
				objeto.getTitulo() == null || objeto.getTitulo().equals(""))
		{
			throw new RGMSException("Dados invlidos na insero da linha de pesquisa.");
		}
	}
	
	public LinhaPesquisa getLinhaPesquisa(int idLinha) {
		Persistence.getInstance().beginTransaction();
		
		LinhaPesquisa retorno =  this.dao.getLinhaPesquisa(idLinha);
		
		Persistence.getInstance().commit();
		
		return retorno;
	}
	
	public List<LinhaPesquisa> getLinhasPesquisa(HashMap<String, String> formfields) {
		Persistence.getInstance().beginTransaction();
		
		List<LinhaPesquisa> retorno =  this.dao.getLinhasPesquisa(formfields);
		
		Persistence.getInstance().commit();
		
		return retorno;
	}
}
