package br.ufpe.cin.rgms.linhasdepesquisa.persistencia;

import java.util.HashMap;
import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.criterion.Order;
import org.hibernate.criterion.Restrictions;

import br.ufpe.cin.rgms.base.Dao;
import br.ufpe.cin.rgms.base.Persistence;
import br.ufpe.cin.rgms.linhasdepesquisa.modelo.LinhaPesquisa;

public class DaoLinhaPesquisa extends Dao<LinhaPesquisa> {

	public DaoLinhaPesquisa() {
		super(LinhaPesquisa.class);
	}

	@Override
	protected String getFirstAtributoDeOrdenacao() {
		return "titulo";
	}

	@Override
	protected String getSecondAtributoDeOrdenacao() {
		return "breveDescricao";
	}

	public LinhaPesquisa getLinhaPesquisa(int idLinha) {
		LinhaPesquisa retorno = null;

		Criteria criteria = Persistence.getInstance().getSession().createCriteria(LinhaPesquisa.class);

		criteria.add(Restrictions.eq("id", idLinha));

		List<LinhaPesquisa> lista = criteria.list();

		if(lista.size() > 0){
			retorno = lista.get(0);
		}

		return retorno;
	}

	public List<LinhaPesquisa> getLinhasPesquisa(HashMap<String, String> formfields) {
		Criteria criteria = Persistence.getInstance().getSession().createCriteria(LinhaPesquisa.class);

		criteria.addOrder(Order.asc(this.getFirstAtributoDeOrdenacao()));
		criteria.addOrder(Order.asc(this.getSecondAtributoDeOrdenacao()));

		for(String campo : formfields.keySet()){
			String like = "%" + formfields.get(campo) + "%";

			criteria.add(Restrictions.ilike(campo, like));
		}

		return criteria.list();
	}
}
