package br.ufpe.cin.rgms.publicacao.modelo;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.List;

import javax.persistence.Basic;
import javax.persistence.Entity;

import br.ufpe.cin.rgms.membro.modelo.Membro;

@Entity
public class ArtigoConferencia extends Publicacao {
	
	private String conferencia;
	
	private String paginasConf;
	
	private String mes;
	
	public ArtigoConferencia() {
		// TODO Auto-generated constructor stub
	}

	public ArtigoConferencia(List<Membro> autores,
			List<String> autoresNaoMembros, String titulo, String ano, byte[] pdf,
			String conferencia, String paginas, String mes, String tipo) {
		super(autores, autoresNaoMembros, titulo, ano, pdf, tipo);
		
		this.setConferencia(conferencia);
		this.setPaginas(paginas);
		this.setMes(mes);
	}

	@Basic
	public String getConferencia() {
		return conferencia;
	}

	public void setConferencia(String conferencia) {
		this.conferencia = conferencia;
	}

	@Basic
	public String getPaginas() {
		return paginasConf;
	}

	public void setPaginas(String paginas) {
		this.paginasConf = paginas;
	}

	@Basic
	public String getMes() {
		return mes;
	}

	public void setMes(String mes) {
		this.mes = mes;
	}
	
	public File createBibTex(){
		File bib = new File(this.getTitulo()+".bib");
		String autoresMembros = (this.listaAutoresMembros()!=null)? this.listaAutoresMembros(): "";
		String autoresNaoMembros = (this.listaAutoresNaoMembros()!=null)? this.listaAutoresNaoMembros():"";
	
		try{
			bib.createNewFile();
			bib.setWritable(true);
			
			FileWriter writer = new FileWriter(bib);
			PrintWriter saida= new PrintWriter(writer);
	
			saida.println("@conference{"+this.getTitulo().trim()+",");
			saida.println("author = \""+autoresMembros+" "+autoresNaoMembros+"\",");
			saida.println("title = \""+this.getTitulo()+"\",");
			saida.println("booktitle = \""+this.getConferencia()+"\",");
			saida.println("year = \""+this.getAno()+"\",");
			saida.println("}");
			
			saida.close();
			writer.close();
			  
		}catch(IOException error){
			error.getMessage();
		}
		
		return bib;
	}
}
