package br.ufpe.cin.rgms.publicacao.modelo;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.List;

import javax.persistence.Basic;
import javax.persistence.Entity;

import br.ufpe.cin.rgms.membro.modelo.Membro;

@Entity
public class ArtigoPeriodico extends Publicacao {
	
	private String jornal;
	
	private String volume;
	
	private String numero;
	
	private String paginas;
	
	public ArtigoPeriodico() {
		// TODO Auto-generated constructor stub
	}

	public ArtigoPeriodico(List<Membro> autores,
			List<String> autoresNaoMembros, String titulo, String ano, byte[] pdf,
			String jornal, String volume, String numero, String paginas, String tipo) {
		super(autores, autoresNaoMembros, titulo, ano, pdf, tipo);
		
		this.setJornal(jornal);
		this.setVolume(volume);
		this.setNumero(numero);
		this.setPaginas(paginas);
	}

	@Basic
	public String getJornal() {
		return jornal;
	}

	public void setJornal(String jornal) {
		this.jornal = jornal;
	}

	@Basic
	public String getVolume() {
		return volume;
	}

	public void setVolume(String volume) {
		this.volume = volume;
	}

	@Basic
	public String getNumero() {
		return numero;
	}

	public void setNumero(String numero) {
		this.numero = numero;
	}

	@Basic
	public String getPaginas() {
		return paginas;
	}

	public void setPaginas(String paginas) {
		this.paginas = paginas;
	}
	
	public File createBibTex(){
		File bib = new File(this.getTitulo()+".bib");
		String autoresMembros = (this.listaAutoresMembros()!=null)? this.listaAutoresMembros(): "";
		String autoresNaoMembros = (this.listaAutoresNaoMembros()!=null)? this.listaAutoresNaoMembros():"";
	
		try{
			bib.createNewFile();
			bib.setWritable(true);
			
			FileWriter writer = new FileWriter(bib);
			PrintWriter saida= new PrintWriter(writer);
	
			saida.println("@article{"+this.getTitulo().trim()+",");
			saida.println("author = \""+autoresMembros+" "+autoresNaoMembros+"\",");
			saida.println("title = \""+this.getTitulo()+"\",");
			saida.println("journal = \""+this.getJornal()+"\",");
			saida.println("year = \""+this.getAno()+"\",");
			saida.println("}");
			
			saida.close();
			writer.close();
			  
		}catch(IOException error){
			error.getMessage();
		}
		
		return bib;
	}
}
